"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _compose = _interopRequireDefault(require("recompose/compose"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _inflection = _interopRequireDefault(require("inflection"));

var _raCore = require("ra-core");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _color = _interopRequireDefault(require("@bootstrap-styled/color"));

var _Confirm = _interopRequireDefault(require("../layout/Confirm"));

var _Button = _interopRequireDefault(require("./Button"));

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var basePath = _ref.basePath,
      crudDeleteMany = _ref.crudDeleteMany,
      filterValues = _ref.filterValues,
      label = _ref.label,
      resource = _ref.resource,
      selectedIds = _ref.selectedIds,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["basePath", "crudDeleteMany", "filterValues", "label", "resource", "selectedIds"]);
  return rest;
};

var StyledButton = (0, _styledComponents.default)(_Button.default).withConfig({
  displayName: "BulkDeleteWithConfirmButton__StyledButton",
  componentId: "sc-1tnb6pk-0"
})(["", ""], function (props) {
  return "\n    color: ".concat(props.theme.$red, " \n    &:hover {\n      background-color: ").concat((0, _color.default)(props.theme.$red.fade(0.12).toString()), "\n    }\n  ");
});

var BulkDeleteWithConfirmButton = function (_Component) {
  (0, _inherits2.default)(BulkDeleteWithConfirmButton, _Component);

  function BulkDeleteWithConfirmButton() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, BulkDeleteWithConfirmButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(BulkDeleteWithConfirmButton)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      isOpen: false
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleClick", function (e) {
      _this.setState({
        isOpen: true
      });

      e.stopPropagation();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleDialogClose", function () {
      _this.setState({
        isOpen: false
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleDelete", function () {
      var _this$props = _this.props,
          basePath = _this$props.basePath,
          crudDeleteMany = _this$props.crudDeleteMany,
          resource = _this$props.resource,
          selectedIds = _this$props.selectedIds,
          onClick = _this$props.onClick;
      crudDeleteMany(resource, selectedIds, basePath);

      if (typeof onClick === 'function') {
        onClick();
      }
    });
    return _this;
  }

  (0, _createClass2.default)(BulkDeleteWithConfirmButton, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          classes = _this$props2.classes,
          label = _this$props2.label,
          icon = _this$props2.icon,
          onClick = _this$props2.onClick,
          resource = _this$props2.resource,
          selectedIds = _this$props2.selectedIds,
          translate = _this$props2.translate,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["classes", "label", "icon", "onClick", "resource", "selectedIds", "translate"]);
      return _react.default.createElement(_react.Fragment, null, _react.default.createElement(StyledButton, (0, _extends2.default)({
        onClick: this.handleClick,
        label: label
      }, sanitizeRestProps(rest)), icon), _react.default.createElement(_Confirm.default, {
        isOpen: this.state.isOpen,
        title: "ra.message.bulk_delete_title",
        content: "ra.message.bulk_delete_content",
        translateOptions: {
          smart_count: selectedIds.length,
          name: _inflection.default.humanize(translate("resources.".concat(resource, ".name"), {
            smart_count: selectedIds.length,
            _: _inflection.default.inflect(resource, selectedIds.length)
          }), true)
        },
        onConfirm: this.handleDelete,
        onClose: this.handleDialogClose
      }));
    }
  }]);
  return BulkDeleteWithConfirmButton;
}(_react.Component);

(0, _defineProperty2.default)(BulkDeleteWithConfirmButton, "propTypes", {
  basePath: _propTypes.default.string,
  crudDeleteMany: _propTypes.default.func.isRequired,
  label: _propTypes.default.string,
  resource: _propTypes.default.string.isRequired,
  selectedIds: _propTypes.default.arrayOf(_propTypes.default.any).isRequired,
  icon: _propTypes.default.element
});
(0, _defineProperty2.default)(BulkDeleteWithConfirmButton, "defaultProps", {
  label: 'ra.action.delete',
  icon: _react.default.createElement(_Delete.default, null)
});
var EnhancedBulkDeleteWithConfirmButton = (0, _compose.default)((0, _reactRedux.connect)(undefined, {
  crudDeleteMany: _raCore.crudDeleteMany
}), _raCore.translate)(BulkDeleteWithConfirmButton);
var _default = EnhancedBulkDeleteWithConfirmButton;
exports.default = _default;
module.exports = exports.default;