"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _compose = _interopRequireDefault(require("recompose/compose"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _classnames = _interopRequireDefault(require("classnames"));

var _inflection = _interopRequireDefault(require("inflection"));

var _raCore = require("ra-core");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _color = _interopRequireDefault(require("@bootstrap-styled/color"));

var _Confirm = _interopRequireDefault(require("../layout/Confirm"));

var _Button = _interopRequireDefault(require("./Button"));

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var basePath = _ref.basePath,
      crudDelete = _ref.crudDelete,
      filterValues = _ref.filterValues,
      handleSubmit = _ref.handleSubmit,
      handleSubmitWithRedirect = _ref.handleSubmitWithRedirect,
      invalid = _ref.invalid,
      label = _ref.label,
      pristine = _ref.pristine,
      resource = _ref.resource,
      saving = _ref.saving,
      selectedIds = _ref.selectedIds,
      submitOnEnter = _ref.submitOnEnter,
      redirect = _ref.redirect,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["basePath", "crudDelete", "filterValues", "handleSubmit", "handleSubmitWithRedirect", "invalid", "label", "pristine", "resource", "saving", "selectedIds", "submitOnEnter", "redirect"]);
  return rest;
};

var StyledButton = (0, _styledComponents.default)(_Button.default).withConfig({
  displayName: "DeleteWithConfirmButton__StyledButton",
  componentId: "b0rgp4-0"
})(["", ""], function (props) {
  return "\n    color: ".concat(props.theme.$red, " \n    &:hover {\n      background-color: ").concat((0, _color.default)(props.theme.$red.fade(0.12).toString()), "\n    }\n  ");
});

var DeleteWithConfirmButton = function (_Component) {
  (0, _inherits2.default)(DeleteWithConfirmButton, _Component);

  function DeleteWithConfirmButton() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, DeleteWithConfirmButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(DeleteWithConfirmButton)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      isOpen: false
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleClick", function (e) {
      _this.setState({
        isOpen: true
      });

      e.stopPropagation();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleDialogClose", function () {
      _this.setState({
        isOpen: false
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleDelete", function () {
      var _this$props = _this.props,
          crudDelete = _this$props.crudDelete,
          resource = _this$props.resource,
          record = _this$props.record,
          basePath = _this$props.basePath,
          redirect = _this$props.redirect;
      crudDelete(resource, record.id, record, basePath, redirect);
    });
    return _this;
  }

  (0, _createClass2.default)(DeleteWithConfirmButton, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          icon = _this$props2.icon,
          _this$props2$label = _this$props2.label,
          label = _this$props2$label === void 0 ? 'ra.action.delete' : _this$props2$label,
          onClick = _this$props2.onClick,
          record = _this$props2.record,
          resource = _this$props2.resource,
          translate = _this$props2.translate,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["className", "icon", "label", "onClick", "record", "resource", "translate"]);
      return _react.default.createElement(_react.Fragment, null, _react.default.createElement(StyledButton, (0, _extends2.default)({
        onClick: this.handleClick,
        label: label,
        className: (0, _classnames.default)('ra-delete-button', className)
      }, sanitizeRestProps(rest)), icon), _react.default.createElement(_Confirm.default, {
        isOpen: this.state.isOpen,
        title: "ra.message.delete_title",
        content: "ra.message.delete_content",
        translateOptions: {
          name: _inflection.default.humanize(translate("resources.".concat(resource, ".name"), {
            smart_count: 1,
            _: _inflection.default.singularize(resource)
          }), true),
          id: record.id
        },
        onConfirm: this.handleDelete,
        onClose: this.handleDialogClose
      }));
    }
  }]);
  return DeleteWithConfirmButton;
}(_react.Component);

DeleteWithConfirmButton.propTypes = {
  basePath: _propTypes.default.string,
  className: _propTypes.default.string,
  crudDelete: _propTypes.default.func.isRequired,
  label: _propTypes.default.string,
  record: _propTypes.default.object,
  redirect: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func]),
  resource: _propTypes.default.string.isRequired,
  translate: _propTypes.default.func,
  icon: _propTypes.default.element
};
DeleteWithConfirmButton.defaultProps = {
  redirect: 'list',
  icon: _react.default.createElement(_Delete.default, null)
};

var _default = (0, _compose.default)((0, _reactRedux.connect)(null, {
  crudDelete: _raCore.crudDelete
}), _raCore.translate)(DeleteWithConfirmButton);

exports.default = _default;
module.exports = exports.default;